Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java	(revision 53)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java	(revision 1)
@@ -20,8 +20,7 @@
 import geniusweb.deadline.DeadlineTime;
 import geniusweb.protocol.session.SessionSettings;
-import geniusweb.protocol.session.TeamInfo;
-import geniusweb.references.Parameters;
+import geniusweb.protocol.session.saop.SAOPSettings;
 import geniusweb.references.PartyRef;
-import geniusweb.references.PartyWithParameters;
+import geniusweb.references.PartyWithProfile;
 import geniusweb.references.ProfileRef;
 import tudelft.utilities.junit.GeneralTests;
@@ -30,11 +29,11 @@
 public class SAOPSettingsTest extends GeneralTests<SAOPSettings> {
 
-	private TeamInfo partyprof1 = mock(TeamInfo.class);
-	private TeamInfo partyprof2 = mock(TeamInfo.class);
-	private TeamInfo partyprof3 = mock(TeamInfo.class);
-	private List<TeamInfo> participants2 = Arrays.asList(partyprof1,
+	private PartyWithProfile partyprof1 = mock(PartyWithProfile.class);
+	private PartyWithProfile partyprof2 = mock(PartyWithProfile.class);
+	private PartyWithProfile partyprof3 = mock(PartyWithProfile.class);
+	private List<PartyWithProfile> participants2 = Arrays.asList(partyprof1,
 			partyprof2);
-	private List<TeamInfo> participants3 = Arrays.asList(partyprof1, partyprof2,
-			partyprof3);
+	private List<PartyWithProfile> participants3 = Arrays.asList(partyprof1,
+			partyprof2, partyprof3);
 
 	private DeadlineTime deadline = mock(DeadlineTime.class);
@@ -47,5 +46,5 @@
 
 	private SAOPSettings sersettings;
-	private final String serialized = "{\"SAOPSettings\":{\"participants\":[{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"http://party1\",\"parameters\":{}},\"profile\":\"http://profile1\"}]}},{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"http://party2\",\"parameters\":{}},\"profile\":\"http://profile2\"}]}}],\"deadline\":{\"DeadlineTime\":{\"durationms\":100}}}}";
+	private final String serialized = "{\"SAOPSettings\":{\"participants\":[{\"party\":\"http://party1\",\"profile\":\"http://profile1\"},{\"party\":\"http://party2\",\"profile\":\"http://profile2\"}],\"deadline\":{\"deadlinetime\":{\"durationms\":100}}}}";
 
 	@Before
@@ -55,8 +54,4 @@
 		when(deadline2.toString()).thenReturn("deadline2");
 
-		when(partyprof1.getSize()).thenReturn(1);
-		when(partyprof2.getSize()).thenReturn(1);
-		when(partyprof3.getSize()).thenReturn(1);
-
 		when(partyprof1.toString()).thenReturn("party and profile 1");
 		when(partyprof2.toString()).thenReturn("party and profile 2");
@@ -65,13 +60,13 @@
 		// SERIALIZABLE version with REAL objects. Still no workaround for
 		// this...
-		PartyWithParameters party1 = new PartyWithParameters(
-				new PartyRef("http://party1"), new Parameters());
+		PartyRef party1 = new PartyRef("http://party1");
 		ProfileRef profile1 = new ProfileRef("http://profile1");
-		PartyWithParameters party2 = new PartyWithParameters(
-				new PartyRef("http://party2"), new Parameters());
+		PartyRef party2 = new PartyRef("http://party2");
 		ProfileRef profile2 = new ProfileRef("http://profile2");
-		TeamInfo partywithprof1 = new TeamInfo(party1, profile1);
-		TeamInfo partywithprof2 = new TeamInfo(party2, profile2);
-		List<TeamInfo> participants = Arrays.asList(partywithprof1,
+		PartyWithProfile partywithprof1 = new PartyWithProfile(party1,
+				profile1);
+		PartyWithProfile partywithprof2 = new PartyWithProfile(party2,
+				profile2);
+		List<PartyWithProfile> participants = Arrays.asList(partywithprof1,
 				partywithprof2);
 
@@ -143,5 +138,5 @@
 		SAOPSettings saop = new SAOPSettings(participants2, deadline);
 		SessionSettings saop2 = saop.with(partyprof3);
-		assertEquals(3, saop2.getTeams().size());
+		assertEquals(3, saop2.getParticipants().size());
 	}
 
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 53)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 1)
@@ -9,6 +9,4 @@
 import static org.mockito.Mockito.when;
 
-import java.io.IOException;
-import java.net.URISyntaxException;
 import java.util.Arrays;
 import java.util.Date;
@@ -18,7 +16,4 @@
 import org.junit.Before;
 import org.junit.Test;
-
-import com.fasterxml.jackson.core.JsonProcessingException;
-import com.fasterxml.jackson.databind.ObjectMapper;
 
 import geniusweb.actions.Accept;
@@ -27,19 +22,12 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
-import geniusweb.deadline.Deadline;
-import geniusweb.deadline.DeadlineTime;
 import geniusweb.issuevalue.Bid;
 import geniusweb.progress.Progress;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.progress.ProgressTime;
-import geniusweb.protocol.NegoState;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
-import geniusweb.protocol.session.TeamInfo;
-import geniusweb.references.Parameters;
-import geniusweb.references.PartyRef;
-import geniusweb.references.PartyWithParameters;
-import geniusweb.references.PartyWithProfile;
-import geniusweb.references.ProfileRef;
+import geniusweb.protocol.partyconnection.ConnectionWithParties;
+import geniusweb.protocol.partyconnection.ConnectionWithParty;
+import geniusweb.protocol.session.SessionSettings;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -50,21 +38,24 @@
 	private PartyId party2 = new PartyId("party2");
 	private PartyId party3 = new PartyId("party3");
-	private List<Action> actions1 = new LinkedList<>();
+	private List<Action> actions = new LinkedList<>();
 	private Action action = mock(Action.class);
 	private List<Action> actions2 = Arrays.asList(action);
 
-	private ProtocolToPartyConn party1conn = mock(ProtocolToPartyConn.class);
-	private ProtocolToPartyConn party2conn = mock(ProtocolToPartyConn.class);
-	private ProtocolToPartyConn party3conn = mock(ProtocolToPartyConn.class);
-
-	private List<PartyId> connections = Arrays.asList(party1, party2);
-	private List<PartyId> connections2 = Arrays.asList(party1, party3);
-	private List<PartyId> connections3 = Arrays.asList(party1, party2, party3);
+	private ConnectionWithParty party1conn = mock(ConnectionWithParty.class);
+	private ConnectionWithParty party2conn = mock(ConnectionWithParty.class);
+	private ConnectionWithParty party3conn = mock(ConnectionWithParty.class);
+
+	private ConnectionWithParties connections = new ConnectionWithParties(
+			Arrays.asList(party1conn, party2conn));
+	private ConnectionWithParties connections2 = new ConnectionWithParties(
+			Arrays.asList(party1conn, party3conn));
+	private ConnectionWithParties connections3 = new ConnectionWithParties(
+			Arrays.asList(party1conn, party2conn, party3conn));
 
 	private Progress progresstime = mock(ProgressTime.class);
 	private ProgressRounds progressrounds = mock(ProgressRounds.class);
 	private ProgressRounds progressrounds1 = mock(ProgressRounds.class);
-	private SAOPSettings settings = mock(SAOPSettings.class);
-	private SAOPState state, state1, state1a, state2, state3, state4;
+	private SessionSettings settings = mock(SAOPSettings.class);
+	private SAOPState state1, state1a, state2, state3, state4;
 
 	private Bid bid1 = mock(Bid.class);
@@ -76,10 +67,6 @@
 	private EndNegotiation endNegotiation1 = new EndNegotiation(party1);
 
-	private final ObjectMapper jackson = new ObjectMapper();
-
-	private String serialized = "{\"SAOPState\":{\"actions\":[],\"connections\":[\"party1\",\"party2\"],\"progress\":{\"ProgressTime\":{\"duration\":1000000,\"start\":2000000}},\"settings\":{\"SAOPSettings\":{\"participants\":[{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"party1ref\",\"parameters\":{}},\"profile\":\"prof1\"}]}}],\"deadline\":{\"DeadlineTime\":{\"durationms\":123000}}}},\"partyprofiles\":{},\"error\":null}}";
-
 	@Before
-	public void before() throws URISyntaxException {
+	public void before() {
 		when(party1conn.getParty()).thenReturn(party1);
 		when(party2conn.getParty()).thenReturn(party2);
@@ -96,26 +83,14 @@
 		when(progressrounds.advance()).thenReturn(progressrounds1);
 
-		state1 = new SAOPState(actions1, connections, progresstime, settings,
-				null, null);
-		state1a = new SAOPState(actions1, connections, progresstime, settings,
+		state1 = new SAOPState(actions, connections, progresstime, settings,
+				null, null);
+		state1a = new SAOPState(actions, connections, progresstime, settings,
 				null, null);
 		state2 = new SAOPState(actions2, connections, progresstime, settings,
 				null, null);
-		state3 = new SAOPState(actions1, connections2, progresstime, settings,
-				null, null);
-		state4 = new SAOPState(actions1, connections, progressrounds, settings,
-				null, null);
-
-		List<PartyId> conns = Arrays.asList(party1, party2);
-		PartyWithParameters pwithp = new PartyWithParameters(
-				new PartyRef("party1ref"), new Parameters());
-		List<PartyWithProfile> teams = Arrays
-				.asList(new PartyWithProfile(pwithp, new ProfileRef("prof1")));
-		List<TeamInfo> participants = Arrays.asList(new TeamInfo(teams));
-		Deadline deadline = new DeadlineTime(123000);
-		SAOPSettings setts = new SAOPSettings(participants, deadline);
-		state = new SAOPState(actions1, conns,
-				new ProgressTime(1000000l, new Date(2000000l)), setts, null,
-				null);
+		state3 = new SAOPState(actions, connections2, progresstime, settings,
+				null, null);
+		state4 = new SAOPState(actions, connections, progressrounds, settings,
+				null, null);
 
 	}
@@ -131,19 +106,19 @@
 	public List<String> getGeneralTestStrings() {
 		return Arrays.asList(
-				"SAOPState.*\\[\\].*party1.*party2.*ProgressTime.*",
-				"SAOPState.*\\[act1\\].*party1.*party2.*ProgressTime.*",
-				"SAOPState.*party1.*party3.*ProgressTime.*",
-				"SAOPState.*party1.*party2.*ProgressRounds.*");
+				"SAOPState.*\\[\\].*ConnectionWithParties.*conn1.*conn2.*ProgressTime.*",
+				"SAOPState.*\\[act1\\].*ConnectionWithParties.*conn1.*conn2.*ProgressTime.*",
+				"SAOPState.*ConnectionWithParties.*conn1.*conn3.*ProgressTime.*",
+				"SAOPState.*ConnectionWithParties.*conn1.*conn2.*ProgressRounds.*");
 	}
 
 	@Test
 	public void constructWith0Connection() {
-		new SAOPState(actions1, Arrays.asList(), progresstime, settings, null,
-				null);
+		new SAOPState(actions, new ConnectionWithParties(Arrays.asList()),
+				progresstime, settings, null, null);
 	}
 
 	@Test
 	public void constructWithNullConnection() {
-		SAOPState state = new SAOPState(actions1, null, progresstime, settings,
+		SAOPState state = new SAOPState(actions, null, progresstime, settings,
 				null, null);
 		assertEquals(0, state.getConnections().size());
@@ -157,6 +132,7 @@
 	@Test
 	public void testNextActor2() {
-		List<PartyId> conns = Arrays.asList(party2, party3);
-		SAOPState state = new SAOPState(actions1, conns, progresstime, settings,
+		ConnectionWithParties conns = new ConnectionWithParties(
+				Arrays.asList(party2conn, party3conn));
+		SAOPState state = new SAOPState(actions, conns, progresstime, settings,
 				null, null);
 		assertEquals(party2, state.getNextActor());
@@ -182,5 +158,5 @@
 	public void isFinalTest() {
 		assertFalse(state1.isFinal(NOW));
-		SAOPState state = new SAOPState(actions1, connections, progresstime,
+		SAOPState state = new SAOPState(actions, connections, progresstime,
 				settings, null, mock(ProtocolException.class));
 		assertTrue(state.isFinal(NOW));
@@ -200,5 +176,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertTrue(state.getAgreements().getMap().isEmpty());
+		assertNull(state.getAgreement());
 	}
 
@@ -208,5 +184,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertTrue(state.getAgreements().getMap().isEmpty());
+		assertNull(state.getAgreement());
 	}
 
@@ -216,5 +192,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertTrue(state.getAgreements().getMap().isEmpty());
+		assertNull(state.getAgreement());
 	}
 
@@ -224,5 +200,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertEquals(bid1, state.getAgreements().getMap().get(party1));
+		assertEquals(bid1, state.getAgreement());
 		assertTrue(state.isFinal(NOW));
 	}
@@ -233,5 +209,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertTrue(state.getAgreements().getMap().isEmpty());
+		assertEquals(null, state.getAgreement());
 	}
 
@@ -241,16 +217,30 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertTrue(state.getAgreements().getMap().isEmpty());
-	}
-
-	@Test(expected = IllegalArgumentException.class)
+		assertEquals(null, state.getAgreement());
+	}
+
+	@Test
+	public void withWrongActionTest() {
+		// wrong because action has actor null which does not match party1
+		SAOPState state = state1.with(party1, action);
+		assertEquals(1, state.getActions().size());
+		assertEquals(action, state.getActions().get(0));
+		assertTrue(state.isFinal(NOW));
+		assertEquals(
+				"geniusweb.protocol.ProtocolException: party1:act contains wrong credentials: act1",
+				state.getError().toString());
+	}
+
+	@Test
 	public void withActionTest() {
 		when(action.getActor()).thenReturn(party1);
-		state1.with(party1, action);
+		SAOPState state = state1.with(party1, action);
+		assertEquals(1, state.getActions().size());
+		assertEquals(action, state.getActions().get(0));
 	}
 
 	@Test
 	public void withConnectionTest() {
-		SAOPState state = state1.with(party3, (PartyWithProfile) null);
+		SAOPState state = state1.with(party3conn, null);
 		assertEquals(3, state.getConnections().size());
 	}
@@ -261,5 +251,5 @@
 		SAOPState state = new SAOPState(actions, connections3, progressrounds,
 				settings, null, null);
-		assertTrue(state.getAgreements().getMap().isEmpty());
+		assertEquals(null, state.getAgreement());
 		assertEquals(null, state.getError());
 		assertTrue(state.isFinal(NOW));
@@ -269,18 +259,21 @@
 	@Test
 	public void isProtocolErrorFinal() {
-		SAOPState state = new SAOPState(actions1, connections3, progressrounds,
-				settings, null,
-				new ProtocolException("test error", new PartyId("test")));
+		SAOPState state = new SAOPState(actions, connections3, progressrounds,
+				settings, null, new ProtocolException("test error", "test"));
 		assertTrue(state.isFinal(NOW));
 		assertNotNull(state.getError());
 	}
 
-	@Test(expected = IllegalArgumentException.class)
+	@Test
 	public void RefuseImmediateAccept() {
 		Accept nullaccept = new Accept(party1, null);
-		state1.with(party1, nullaccept);
-	}
-
-	@Test(expected = IllegalArgumentException.class)
+		SAOPState state = state1.with(party1, nullaccept);
+		assertTrue(state.isFinal(NOW));
+		assertEquals(
+				"geniusweb.protocol.ProtocolException: party1:Accept without a recent offer",
+				state.getError().toString());
+	}
+
+	@Test
 	public void RefuseNotMyTurn() {
 		List<Action> actions = Arrays.asList(offer1);
@@ -288,8 +281,12 @@
 				settings, null, null);
 
-		state.with(party1, offer1);
-	}
-
-	@Test(expected = IllegalArgumentException.class)
+		state = state.with(party1, offer1);
+		assertTrue(state.isFinal(NOW));
+		assertEquals(
+				"geniusweb.protocol.ProtocolException: party1:actor does not have the turn ",
+				state.getError().toString());
+	}
+
+	@Test
 	public void RefuseNullAccept() {
 		List<Action> actions = Arrays.asList(offer1);
@@ -300,7 +297,9 @@
 		state = state.with(party2, nullaccept);
 		assertTrue(state.isFinal(NOW));
-	}
-
-	@Test(expected = IllegalArgumentException.class)
+		assertTrue(state.getError().toString()
+				.matches(".*party2.*Accepts a bid that was not offered.*"));
+	}
+
+	@Test
 	public void RefuseNullAction() {
 		List<Action> actions = Arrays.asList(offer1);
@@ -308,5 +307,8 @@
 				settings, null, null);
 
-		state = state.with(party2, (Action) null);
+		state = state.with(party2, null);
+		assertEquals(
+				"geniusweb.protocol.ProtocolException: party2:action is null",
+				state.getError().toString());
 	}
 
@@ -321,5 +323,5 @@
 		assertTrue(state.isFinal(NOW));
 		assertNull(state.getError());
-		assertEquals(bid1, state.getAgreements().getMap().get(party1));
+		assertEquals(bid1, state.getAgreement());
 
 	}
@@ -337,23 +339,6 @@
 		assertTrue(state.isFinal(NOW));
 		assertNull(state.getError());
-		assertEquals(bid2, state.getAgreements().getMap().get(party1));
-
-	}
-
-	@Test
-	public void testDeserialize() throws IOException {
-		NegoState obj = jackson.readValue(serialized, NegoState.class);
-		System.out.println(obj);
-		assertEquals(state, obj);
-	}
-
-	@Test
-	public void testSerialize()
-			throws JsonProcessingException, URISyntaxException {
-
-		String string = jackson.writeValueAsString(state);
-		System.out.println(string);
-		assertEquals(serialized, string);
-	}
-
+		assertEquals(bid2, state.getAgreement());
+
+	}
 }
